<?php

function spbc_perform_scan_wrapper($state = null){
	
	global $spbc;
	
	if($spbc->scaner_status === false)
		return;
	
	if($state === null && $spbc->data['scanner']['cron']['state'] !== 'get_hashes'){
		return;
	}
	
	if($state){
		$spbc->data['scanner']['cron']['state'] = $state;
		$spbc->save('data');;
	}
	
	$state = $spbc->data['scanner']['cron']['state'];
	$call_period = 5;
	
	switch($state){
		
	// Preparing
		case 'get_hashes':
			// Getting hashes
			$result = spbc_scanner_get_remote_hashes(true);
			if(!empty($result['error'])){
				$call_period = 300;
				$out = array('error' => true, 'error_string' => 'Background scan: Get hashes: '.$result['error_string']);
			}
			$spbc->error_delete('get_hashs', 'and_save_data');
			
			$state = 'get_hashes_plug';
			
		break;
			
		case 'get_hashes_plug':
			$result = spbc_scanner_get_remote_hashes__plug(true);
			if(!empty($result['error'])){
				$call_period = 300;
				$out = array('error' => true, 'error_string' => 'Background scan: Get hashes: '.$result['error_string']);
			}
			
			if($result['scanned'] <= 2){
				$state =  'surface_scan';
				// Clearing table
				spbc_scanner_clear_table(true);
			}else{
				$state = 'get_hashes_plug';
			}
			
			$spbc->error_delete('get_hashes_plug', 'and_save_data');
			
		break;
		
		// Surface
		case 'surface_scan':
			
			$result = spbc_scanner_scan(true, $spbc->data['scanner']['cron']['offset'], SPBC_SCAN_SURFACE_AMOUNT);
			if(!empty($result['error'])){
				$call_period = 300;
				$out = array('error' => true, 'error_string' => 'Background scan: Surface scan: '.$result['error_string']);
			}
			$spbc->error_delete('scan_modified', 'and_save_data');
			
			if($result['scanned'] != SPBC_SCAN_SURFACE_AMOUNT){
				$state = 'deep_scan';
				$spbc->data['scanner']['cron']['offset'] = 0;
			}else{
				$spbc->data['scanner']['cron']['offset'] += SPBC_SCAN_SURFACE_AMOUNT;
				$spbc->data['scanner']['cron']['total_scanned'] += $result['scanned'];
			}
			
			$spbc->save('data');
			
		break;
		
		// Deep
		case 'deep_scan':
			
			if(empty($spbc->settings['heuristic_analysis'])){
				$state = 'links_scan';
				break;
			}
			
			$result = spbc_scanner_scan_modified(true, 'UNKNOWN,MODIFIED', SPBC_SCAN_MODIFIED_AMOUNT);
			if($result['scanned'] === false){
				$call_period = 300;
				$out = array('error' => true, 'error_string' => 'Background scan: Deep scan: '.$result['error_string']);
			}
			$spbc->error_delete('scan_modified', 'and_save_data');
			
			if($result['scanned'] != SPBC_SCAN_MODIFIED_AMOUNT)
				$state = 'links_scan';
			
		break;
		
	// Links
		case 'links_scan':
			
			if(empty($spbc->settings['scan_outbound_links'])){
				$state = 'send_results';
				break;
			}
			
			$result = spbc_scanner_links_scan(true, SPBC_SCAN_LINKS_AMOUNT);
			// if(!$result['error']){
				// $call_period = 300;
				// $out = array('error' => true, 'error_string' => 'Background scan: Links scan: '.$result['error_string']);
			// }
			// $spbc->error_delete('scan_links', 'and_save_data');
			
			if($result['scanned'] === 0){
				$state = 'send_results';
				$spbc->data['scanner']['cron']['offset'] = 0;
				$spbc->save('data');
			}
			
		break;
		
	// Send result
		case 'send_results':
		
			$result = spbc_scanner_send_results(true, $spbc->data['scanner']['cron']['total_scanned']);
			$spbc->data['scanner']['cron']['state'] = 'get_hashes';
			$spbc->data['scanner']['cron']['total_scanned'] = 0;
			SpbcCron::removeTask('perform_scan_wrapper_act');
			$end = true;
			
			$spbc->save('data');
			
		break;
	}
	
	if(empty($end))
		SpbcCron::updateTask('perform_scan_wrapper_act', 'spbc_perform_scan_wrapper', $call_period, null, array($state));
	
	return isset($out) ? $out : true;
	
}

function spbc_scanner_get_remote_hashes($direct_call = false){
	
	if(!$direct_call) check_ajax_referer('spbc_secret_nonce', 'security');
	
	global $spbc, $wp_version, $wpdb;
	
	if(preg_match('/^[\d\.]*$/', $wp_version) === 1){
		
		$allow_url_fopen = strtolower(ini_get('allow_url_fopen'));
		
		if(($allow_url_fopen === 'on' || $allow_url_fopen === '1')){
			
			if(!isset($spbc->data['scanner']['last_wp_version']) || (isset($spbc->data['scanner']['last_wp_version']) && $spbc->data['scanner']['last_wp_version'] != $wp_version)){
				
				$result = spbc_scanner_clear(true); // Clear scan results
				
				if(empty($result['error'])){
					
					// Getting hashs				
				$start = microtime(true);
					
					$result = SpbcScaner::get_hashes('path', 'wordpress', $wp_version);
					
					if(empty($result['error'])){
						$is_windows = spbc_is_windows() ? true : false;
						$sql = 'INSERT INTO ' . SPBC_TBL_SCAN_FILES . ' (`fast_hash`, `path`, `real_full_hash`) VALUES ';
						foreach($result['checksums'] as $path => $real_full_hash){
							$path = $is_windows ? str_replace('/', '\\', $path) : $path;
							$fast_hash = md5($path);
							$path = addslashes($path);
							$sql .= "('$fast_hash', '$path', '$real_full_hash'),";
						} unset($path, $real_full_hash);
						$sql = substr($sql, 0, -1);
						
						$success = $wpdb->query($sql);
						
				$exec_time = microtime(true) - $start;
						
						$output  = array(
							'files_count' => $result['checksums_count'],
							'exec_time'    => $exec_time,
							'success'      => $success,
						);
						$spbc->data['scanner']['last_wp_version'] = $wp_version;
						$spbc->error_delete('get_hashs', 'and_save_data');
						$spbc->save('data');
						
					}else
						$output = $result;
				}else
					$output  = array('error' => true, 'error_string' => 'Can not clear scan table.',);
			}else
				$output = array('success' => true, 'error_string' => 'Already up to date.',);
		}else
			$output = array('success' => true, 'error_string' => 'allow_url_fopen is disabled',);
	}else
		$output = array('error' => true, 'error_string' => 'Your Wordpress version is not supported');
		
	if($direct_call) return $output; else die(json_encode($output));
}

function spbc_scanner_count_hashes_plug($direct_call = false){
	
	if(!$direct_call) check_ajax_referer('spbc_secret_nonce', 'security');
	
	// Get all plugins
	$plugins = count(spbc_get_plugins());
	
	// Get all themes
	$themes = count(spbc_get_themes());
	
	$output = array(
		'total'   => $plugins + $themes,
		'plugins' => $plugins,
		'themes'  => $themes,
	);
	
	if($direct_call) return $output; else die(json_encode($output));
}

function spbc_scanner_get_remote_hashes__plug($direct_call = false, $amount = 2){
	
	if(!$direct_call) check_ajax_referer('spbc_secret_nonce', 'security');
	
	global $spbc, $wpdb;
	
	$is_windows = spbc_is_windows() ? true : false;
	
	$processed = 0;
	
	// Get all plugins
	$plugins = spbc_get_plugins();
	$spbc->plugins;
	if($spbc->plugins === false)
		$spbc->plugins = array();
	foreach($plugins as $name => $plugin){
		if($processed >= 2) break;
		if(isset($spbc->plugins[$name]) && $spbc->plugins[$name] == $plugin['Version']){
			continue;
		}else{
			$result = SpbcScaner::get_hashes__plug('wordpress', 'plugin', $name, $plugin['Version']);
			if(empty($result['error'])){
				$wpdb->query('DELETE FROM ' . SPBC_TBL_SCAN_FILES . ' WHERE path LIKE "%' . $name . '%";');
				$sql = 'INSERT INTO ' . SPBC_TBL_SCAN_FILES . ' (`fast_hash`, `path`, `real_full_hash`, `source`) VALUES ';
				foreach($result as $value){
					$path = '/' . substr(WP_PLUGIN_DIR . '/' . $value[0], strlen(ABSPATH));
					$path = $is_windows ? str_replace('/', '\\', $path) : $path;
					$fast_hash = md5($path);
					$path = addslashes($path);
					$real_full_hash = $value[1];
					$sql .= "('$fast_hash', '$path', '$real_full_hash', 'PLUGIN'),";
				} unset($value);
				$sql = substr($sql, 0, -1);
				$wpdb->query($sql);
				$spbc->plugins[$name] = $plugin['Version'];
				$processed++;
			}else
				$spbc->plugins[$name] = false;
		}
	}
	
	$spbc->save('plugins', true, false);
	
	// Get all themes
	$themes = spbc_get_themes();
	$theme_path = get_theme_root();
	if($spbc->themes === false)
		$spbc->themes = array();
	foreach($themes as $name => $theme){
		if($processed >= 2) break;
		if(isset($spbc->themes[$name]) && $spbc->themes[$name] == $theme['Version']){
			continue;
		}else{
			$result = SpbcScaner::get_hashes__plug('wordpress', 'theme', $name, $theme['Version']);
			if(empty($result['error'])){
				$wpdb->query('DELETE FROM ' . SPBC_TBL_SCAN_FILES . ' WHERE path LIKE "%' . $name . '%";');
				$sql = 'INSERT INTO ' . SPBC_TBL_SCAN_FILES . ' (`fast_hash`, `path`, `real_full_hash`, `source`) VALUES ';
				foreach($result as $value){
					$path = '/' . substr($theme_path . '/' . $value[0], strlen(ABSPATH));
					$path = $is_windows ? str_replace('/', '\\', $path) : $path;
					$fast_hash = md5($path);
					$path = addslashes($path);
					$real_full_hash = $value[1];
					$sql .= "('$fast_hash', '$path', '$real_full_hash', 'PLUGIN'),";
				} unset($value);
				$sql = substr($sql, 0, -1);
				$wpdb->query($sql);
				$spbc->themes[$name] = $theme['Version'];
				$processed++;
			}else{
				$spbc->themes[$name] = false;
			}
		}
	}
	$spbc->save('themes', true, false);
	
	$output = array(
		'success' => true,
		'scanned' => $processed,
	);
	
	if($direct_call) return $output; else die(json_encode($output));
}

function spbc_scanner_clear_table($direct_call = false, $offset = 0, $amount = 50000){
	
	if(!$direct_call) check_ajax_referer('spbc_secret_nonce', 'security');
	if(!$direct_call){
		$offset = !empty($_POST['offset']) ? $_POST['offset'] : $offset;
		$amount = !empty($_POST['amount']) ? $_POST['amount'] : $amount;
	}
	
	global $spbc, $wpdb;
	
	$time_start = microtime(true);
	
	$result = $wpdb->get_results(
		'SELECT path, fast_hash, status'
			.' FROM ' . SPBC_TBL_SCAN_FILES
			." LIMIT $offset, $amount;",
		ARRAY_A
	);
	
	$root_path = spbc_get_root_path();
	
	$to_delete = "''";
	
	foreach($result as $value){
		if(!file_exists($root_path.$value['path']) && $value['status'] != 'QUARANTINED'){
			$to_delete .= ",'{$value['fast_hash']}'";
		}
	} unset($value);
	
	
	$sql = 'DELETE FROM ' . SPBC_TBL_SCAN_FILES
			." WHERE fast_hash IN ($to_delete);";
	
	
	$result = $wpdb->query($sql	
	);
	
	$output = array(
		'succes'    => $result !== false ? true : false,
		'deleted'   => (int)$result,
		'exec_time' => microtime(true) - $time_start,
	);
	
	if(!$direct_call) die(json_encode($output)); else return $output;
	
}

function spbc_scanner_clear($direct_call = false){
	
	if(!$direct_call) check_ajax_referer('spbc_secret_nonce', 'security');
	
	global $wpdb, $spbc;
	
	$spbc->plugins = array();
	$spbc->save('plugins');
	
	$spbc->themes = array();
	$spbc->save('themes');
	
	$spbc->data['scanner'] = array();
	$spbc->data['scanner'] = array(
		'last_wp_version'      => null,
		'cron' => array(
			'state'         => 'get_hashes',
			'total_scanned' => 0,
			'offset'        => 0,
		),
	);
	$spbc->save('data');
	
	
	$output  = array(
		'error' => $wpdb->query('DELETE FROM ' . SPBC_TBL_SCAN_FILES . ' WHERE 1') === false ? true : false,
	);
	
	if($direct_call) return $output; else die(json_encode($output));
}

function spbc_scanner_count_files($direct_call = false, $path = ABSPATH){
	
	if(!$direct_call) check_ajax_referer('spbc_secret_nonce', 'security');
	
	$path_to_scan = realpath($path);
	$root_path    = realpath(ABSPATH);
	$init_params  = array(
		'count'          => true,
		'file_exceptions' => 'wp-config.php',
		'extensions'      => 'php, html, htm',
		'files_mandatory' => array(),
		'dir_exceptions'  => array(
			str_replace('/', '\/', str_replace('\\', '\\\\', $path_to_scan)).'(\/|\\\\)wp-content(\/|\\\\)'.'(\/|\\\\)plugins(\/|\\\\)'.'(\/|\\\\)security-malware-firewall(\/|\\\\)'.'(\/|\\\\)quarantine(\/|\\\\)?.+',
			)
	);
	
	$scaner = new SpbcScaner($path_to_scan, $root_path, $init_params);
	
	$output = array(
		'files_total' => $scaner->files_count,
	);
	
	if($direct_call) return $output; else die(json_encode($output));
}

function spbc_scanner_count_modified_files($status = null, $direct_call = false, $path = ABSPATH){
	
	if($direct_call === false) check_ajax_referer('spbc_secret_nonce', 'security');
	
	global $wpdb;
	
	$status = !empty($_POST['status']) ? stripslashes($_POST['status']) : $status;
	if(is_string($status)) if(explode(',',$status)) $status = explode(',',$status);
	if(is_array($status))                           $status = implode('\',\'', $status);
		
	$path   = realpath($path);
	$sql = 'SELECT COUNT(fast_hash) AS cnt'
		.' FROM '.SPBC_TBL_SCAN_FILES
		." WHERE checked = 'NO' AND status IN ('$status');";
	$files_count = $wpdb->get_results($sql, ARRAY_A);
	
	$success = $files_count !== null ? true : false;
		
	$output = array(
		'success'     => $success,
		'files_total' => $success ? $files_count[0]['cnt'] : 0,
	);
	
	if($direct_call) return $output; else die(json_encode($output));
}

function spbc_scanner_scan($direct_call = false, $offset = 0, $amount = 1500, $path = ABSPATH){
	
	if(!$direct_call) check_ajax_referer('spbc_secret_nonce', 'security');
	if(!$direct_call){
		$offset = !empty($_POST['offset']) ? $_POST['offset'] : $offset;
		$amount = !empty($_POST['amount']) ? $_POST['amount'] : $amount;
	}
	
	global $spbc, $wpdb;
	
	$_slash = spbc_is_windows() ? '\\' : '/';
	
	$path_to_scan = realpath($path);
	$root_path    = realpath(ABSPATH);
	$init_params = array(
		'fast_hash'        		=> true,
		'full_hash'       		=> true,
		'offset'                => $offset,
		'amount'                => $amount,
		'extensions'            => 'php, html, htm',
		'extensions_exceptions' => '', //array('jpg', 'jpeg', 'png', 'gif', 'css', 'txt', 'zip', 'xml', 'json')
		'file_exceptions'       => 'wp-config.php',
		'files_mandatory' => array(),
		'dir_exceptions'  => array(
			str_replace('/', '\/', str_replace('\\', '\\\\', $path_to_scan)).'(\/|\\\\)wp-content(\/|\\\\)'.'(\/|\\\\)plugins(\/|\\\\)'.'(\/|\\\\)security-malware-firewall(\/|\\\\)'.'(\/|\\\\)quarantine(\/|\\\\)?.+',
			)
	);
	
	$time_start = microtime(true);

	$scaner = new SpbcScaner($path_to_scan, $root_path, $init_params);
		
	if($scaner->files_count){
		
		$sql = 'INSERT INTO ' . SPBC_TBL_SCAN_FILES 
			. ' (`path`, `size`, `perms`, `mtime`,`status`,`fast_hash`, `full_hash`) VALUES ';
		foreach($scaner->files as $key => $file){
			$file['path'] = addslashes($file['path']);
			$sql .="('{$file['path']}','{$file['size']}','{$file['perms']}','{$file['mtime']}','UNKNOWN','{$file['fast_hash']}','{$file['full_hash']}'),"; 
		} unset($key, $file);
		$sql = substr($sql, 0, -1);
		$sql .= " ON DUPLICATE KEY UPDATE
			
			size      = VALUES(`size`),
			perms     = VALUES(`perms`),
			
			fast_hash = fast_hash,
			full_hash = VALUES(`full_hash`),
			real_full_hash = real_full_hash,
			
			checked = 
				IF(real_full_hash IS NOT NULL AND real_full_hash = VALUES(`full_hash`),
					'YES',
					IF(mtime <> VALUES(`mtime`) OR mtime IS NULL,
						'NO',
						checked
					)
				),
			
			status = 
				IF(mtime <> VALUES(`mtime`) OR mtime IS NULL,
					IF(real_full_hash IS NULL,
						IF(checked = 'YES',
							status,
							'UNKNOWN'
						),
						IF(real_full_hash = VALUES(`full_hash`),
							'OK',
							'MODIFIED'
						)
					),
					status
				),
			
			mtime     = VALUES(`mtime`),
			
			severity  =
				IF(status <> 'OK',
					severity,
					NULL
				);";
		
		$success = $wpdb->query($sql);
	}
		
	if(isset($success) && $success === false){
		$output  = array('error' => true, 'error_string'  => 'DataBase write error while scanning files.',);
	}else{
		$output  = array(
			'files_count' => $scaner->files_count,
			'scanned'     => $scaner->files_count,
			'dirs_count'  => $scaner->dirs_count,
			'exec_time'   => microtime(true) - $time_start,
			'offset'      => $offset,
			'success'     => isset($success),
		);
	}

	if(!$direct_call) die(json_encode($output)); else return $output;

}

function spbc_scanner_scan_modified($direct_call = false, $status = 'MODIFIED', $amount = 10, $path = ABSPATH){
	
	if(!$direct_call) check_ajax_referer('spbc_secret_nonce', 'security');
	
	global $wpdb, $wp_version;
	
	$status = !empty($_POST['status']) ? stripslashes($_POST['status']) : $status;
	if(is_string($status)) if(explode(',',$status)) $status = explode(',',$status);
	if(is_array($status))                           $status = implode('\',\'', $status);
	
	$amount = !empty($_POST['amount']) ? $_POST['amount'] : $amount;
	$path   = !empty($_POST['path'])   ? $_POST['path']   : $path;
	$path   = realpath($path);
	
	$time_start = microtime(true);
	
	$sql = 'SELECT path, source, status, fast_hash, real_full_hash'
		.' FROM ' . SPBC_TBL_SCAN_FILES
		." WHERE checked IN ('NO') AND status IN ('$status')"
		." LIMIT $amount";
	$files_to_check = $wpdb->get_results($sql, ARRAY_A);
	
	if(count($files_to_check)){
		
		$root_path = spbc_get_root_path();
		
		foreach($files_to_check as $file){
			
			$result = SpbcScaner::scan_file($root_path, $file, $wp_version);
			
			if($file['status'] === 'MODIFIED'){
				$result['status'] = 'MODIFIED';
			}
			
			$wpdb->update(
				SPBC_TBL_SCAN_FILES,
				array(
					'checked'    => 'YES',
					'status'     => $result['status'],
					'severity'   => $result['severity'],
					'weak_spots' => $result['weak_spots'],
					'difference' => $result['difference'],
				),
				array( 'fast_hash' => $file['fast_hash'] ),
				array( '%s', '%s', '%s', '%s', '%s' ),
				array( '%s' )
			);
		}
	}
	
	$output  = array(
		'scanned'   => count($files_to_check),
		'exec_time' => microtime(true) - $time_start,
	);
	
	if(!$direct_call) die(json_encode($output)); else return $output;

}

function spbc_scanner_links_count($direct_call = false){
	
	if(!$direct_call) check_ajax_referer('spbc_secret_nonce', 'security');
	
	$links_scanner = new SpbcScannerLinks(array('count' => true));
	
	$output  = array(
		'posts_total' => $links_scanner->posts_total,
	);
		
	if($direct_call) return $output; else die(json_encode($output));
}

function spbc_scanner_links_scan($direct_call = false, $amount = 10){
	
	if(!$direct_call) check_ajax_referer('spbc_secret_nonce', 'security');
	if(!$direct_call){
		$amount = isset($_POST['amount']) ? $_POST['amount'] : $amount;
	}
	
	global $wpdb, $spbc;
	$time_start = microtime(true);
	
	$init_params = array(
		'amount' =>$amount,
		'check_default' => false,
		'mirrors' => !empty($spbc->settings['scan_outbound_links_mirrors']) ? $spbc->settings['scan_outbound_links_mirrors'] : '',
	);
	$scanner = new SpbcScannerLinks($init_params);
		
	if (!empty($scanner->links)){
		
		// Getting only new links
		$prev_scanned_links = $wpdb->get_results(
			'SELECT link
				FROM ' . SPBC_TBL_SCAN_LINKS,
			OBJECT_K
		);
		$new_links = array_diff_key($scanner->links, $prev_scanned_links);
				
		if (count($new_links)>0){
			
			// Preparing hosts for backlinks_check_cms
			foreach(array_keys($new_links) as $link){
				$parsed = parse_url($link);
				// Adding $parsed['host'] for link like some.thing
				if(!isset($parsed['host'])){
					preg_match('/^[a-zA-Z0-9-.]+/', '', $matches);
					$parsed['host'] = $matches[0];
				}
				// Check only http links
				if($parsed && (!isset($parsed['sheme']) || (isset($parsed['sheme']) || $parsed['sheme'] === 'http' || $parsed['sheme'] === 'https'))){
					$links_to_check[$link] = $parsed['host'];
				}
			} unset($link);
			
			// Checking links against blacklists
			$result = SpbcHelper::api_method__backlinks_check_cms($spbc->settings['spbc_key'], $links_to_check);
			
			// Adding spam_active flag to newly detected links
			if(empty($result['error'])){
				foreach($links_to_check as $link => $host){
					$new_links[$link]['spam_active'] = isset($result[$host]) ? $result[$host]['appears'] : null;
				} unset($link, $host);
			}
			
			//Getting current scan_id
			$scan_id = $wpdb->get_results(
				'SELECT MAX(scan_id) AS scan_num
					FROM ' . SPBC_TBL_SCAN_LINKS . ';',
				OBJECT
			);
			$scan_id = $scan_id[0]->scan_num + 1;
			
			// Preparing request
			$sql = 
				'INSERT INTO '. SPBC_TBL_SCAN_LINKS .'
					(`scan_id`, `link`, `domain`, `link_text`, `page_url`, `spam_active`)
				VALUES ';
				
			// Preparing data
			$new_links = SpbcHelper::db__prepare_param($new_links);
			foreach($new_links as $link => $param){
				$link = SpbcHelper::db__prepare_param($link);
				$sql .= "($scan_id, $link, {$param['domain']}, {$param['link_text']}, {$param['page_url']}, {$param['spam_active']}),";
			} unset($link, $param);
			$sql = substr($sql, 0, -1).';';
			
			// Adding results to storage table
			$success = $wpdb->query($sql);
		}								
	}
	
	$output  = array(		
		'links_found' => $scanner->links_found,
		'scanned'     => $scanner->posts_checked,
		'exec_time'   => microtime(true) - $time_start,
	);
		
	if($direct_call) return $output; else die(json_encode($output));
}

function spbc_scanner_links_count_found($total = true, /* Out */ $count = 0)
{
	global $wpdb;
	
	$sql_result = $wpdb->get_results(
		'SELECT COUNT(*) AS cnt FROM '. SPBC_TBL_SCAN_LINKS
		.(!$total ? ' WHERE scan_id = (SELECT MAX(scan_id) FROM ' . SPBC_TBL_SCAN_LINKS . ');' : ''), // only latest scan
		ARRAY_A);
	
	if ($sql_result)
		$count = !$sql_result[0]['cnt'] ? 0 : $sql_result[0]['cnt'];
		
	return $count;
	}
	
function spbc_scanner_links_count_found__domains(/* Out */ $count = 0)
{
	global $wpdb;
	$count = $wpdb->get_results(
		'SELECT COUNT(DISTINCT domain) AS cnt FROM '. SPBC_TBL_SCAN_LINKS,
		OBJECT_K);
	return $count ? key($count) : 0;
}

function spbc_scanner_links_get_scanned__domains($offset = 0, $amount = 20, $order = null, $by = null, $get_array = false){
	global $wpdb;
	$offset = intval($offset);
	$amount = intval($amount);
	$data = $wpdb->get_results(
		'SELECT domain, spam_active, COUNT(domain) as link_count
				FROM '. SPBC_TBL_SCAN_LINKS .' 
			GROUP BY domain
			'.($order && $by  ? "ORDER BY $by $order" : '').'
			LIMIT '.$offset.','.$amount.';',
		$get_array === true ? ARRAY_A : OBJECT
	);
	return $data;
}

function spbc_scanner_send_results($direct_call = false, $total_scanned = 0){
	
	global $spbc, $wpdb;
	
	// Getting unknown and modified files.
	$sql = 'SELECT path, size, mtime, status, full_hash
		FROM '.SPBC_TBL_SCAN_FILES.'
		WHERE status IN ("MODIFIED", "INFECTED", "UNKNOWN")';
	$sql_result = $wpdb->get_results($sql, ARRAY_A);
	$rows_count = count($sql_result);
	
	$unknown  = array();
	$modified = array();
	$is_windows = spbc_is_windows() ? true : false;
	if($rows_count){
		foreach($sql_result as $row){
			$row['path'] = $is_windows ? str_replace('\\', '/', $row['path']) : $row['path'];
			if($row['status'] == 'UNKNOWN'){
				$unknown[$row['path']] = array($row['full_hash'], $row['mtime'], $row['size']);
			}else{
				$modified[$row['path']] = array($row['full_hash'], $row['mtime'], $row['size']);
			}
		}
	}
	
	// Count files to scan
	$scanned_total = spbc_scanner_count_files(true);
	$scanned_total = $scanned_total['files_total'];
	
	// API. Sending files scan result
	$result = SpbcHelper::api_method__security_mscan_logs(
		$spbc->settings['spbc_key'],
		$spbc->service_id,
		current_time('Y-m-d H:i:s'),
		$rows_count ? 'warning' : 'passed',
		$scanned_total,
		$modified,
		$unknown
	);
	
	if(empty($result['error'])){
	
		if($spbc->settings['scan_outbound_links']){
		
			$links = $wpdb->get_results(
				'SELECT `link`, `link_text`, `page_url`, `spam_active`
					FROM '. SPBC_TBL_SCAN_LINKS .' 
					WHERE scan_id = (SELECT MAX(scan_id) FROM '. SPBC_TBL_SCAN_LINKS .');',
				OBJECT);
			$links_to_send = array();
			foreach($links as $link){
				$links_to_send[$link->link] = array(
					'link_text'   => $link->link_text,
					'page_url'    => $link->page_url,
					'spam_active' => $link->spam_active,
				);
			}
			$links_to_send = json_encode($links_to_send);
			
			// API. Sending links scan result
			$result = SpbcHelper::api_method__security_linksscan_logs(
				$spbc->settings['spbc_key'],           // 
				current_time('Y-m-d H:i:s'),           // 
				$wpdb->num_rows ? 'failed' : 'passed', // 
				$wpdb->num_rows,                       // Number of links found for last scan
				$links_to_send                         // Links found for last scan
			);
		}
	
		if(empty($result['error'])){
			$spbc->data['scanner']['last_sent']        = current_time('timestamp');
			$spbc->data['scanner']['last_scan']        = current_time('timestamp');
			$spbc->data['scanner']['last_scan_amount'] = isset($_POST['total_scanned']) ? $_POST['total_scanned'] : $total_scanned;
			$spbc->data['scanner']['last_scan_links_amount'] = $wpdb->num_rows;
			$spbc->error_delete('scanner_result_send');			
		}else
			$spbc->error_add('scanner_result_send', $result);
		
	}else
		$spbc->error_add('scanner_result_send', $result);
	
	$spbc->save('data');
	
	if($direct_call) return $result; else die(json_encode($result));
}

function spbc_scanner_file_send($direct_call = false, $file_id = null){
	
	if(!$direct_call)
		check_ajax_referer('spbc_secret_nonce', 'security');
	
	$time_start = microtime(true);
	
	global $spbc, $wpdb;
	
	$root_path = spbc_get_root_path();
	$file_id = $direct_call
		? ($file_id ? $file_id : false)
		: (!empty($_POST['file_id']) ? $_POST['file_id'] : false);
	
	if($file_id){
		
		// Getting file info.
		$sql = 'SELECT path, full_hash, weak_spots
			FROM '.SPBC_TBL_SCAN_FILES.'
			WHERE fast_hash = "'.$file_id.'"
			LIMIT 1';
		$sql_result = $wpdb->get_results($sql, ARRAY_A);
		$file_info = $sql_result[0];
				
		if(!empty($file_info)){
			if(file_exists($root_path.$file_info['path'])){
				if(is_readable($root_path.$file_info['path'])){
					if(filesize($root_path.$file_info['path']) > 0){					
						if(filesize($root_path.$file_info['path']) < 1048570){
					
							// Getting file && API call
							$file = file_get_contents($root_path.$file_info['path']);
							$result = SpbcHelper::api_method__security_mscan_files($spbc->settings['spbc_key'], $file_info['path'], $file, $file_info['full_hash'], $file_info['weak_spots']);
							
							if(empty($result['error'])){
								if($result['result']){
									
									// Updating "last_sent"
									$sql_result = $wpdb->query('UPDATE '.SPBC_TBL_SCAN_FILES.' SET last_sent = '.current_time('timestamp').' WHERE fast_hash = "'.$file_id.'"');
									
									if($sql_result !== false){
										$output = array('success' => true, 'result' => $result);
									}else
										$output = array('error' => true, 'error_string' =>'DB_COULDNT_UPDATE_ROW');
								}else
									$output = array('error' => true, 'error_string' =>'API_RESULT_IS_NULL');
							}else
								$output = $result;
						}else
							$output = array('error' => true, 'error_string' =>'FILE_SIZE_TO_LARGE');
					}else
						$output = array('error' => true, 'error_string' =>'FILE_SIZE_ZERO');
				}else
					$output = array('error' => true, 'error_string' =>'FILE_NOT_READABLE');
			}else
				$output = array('error' => true, 'error_string' =>'FILE_NOT_EXISTS');
		}else
			$output = array('error' => true, 'error_string' =>'FILE_NOT_FOUND');
	}else
		$output = array('error' => true, 'error_string' =>'WRONG_FILE_ID');
	
	$exec_time = microtime(true) - $time_start;
	$output['exec_time'] = $exec_time;
	
	if($direct_call)
		return $output;
	else
		die(json_encode($output));
}

function spbc_scanner_file_delete($direct_call = false, $file_id = null){
	
	if(!$direct_call)
		check_ajax_referer('spbc_secret_nonce', 'security');
	
	$time_start = microtime(true);
	
	global $wpdb;
	
	$root_path = spbc_get_root_path();
	$file_id = $direct_call
		? ($file_id ? $file_id : false)
		: (!empty($_POST['file_id']) ? $_POST['file_id'] : false);
	
	if($file_id){
		
		// Getting file info.
		$sql = 'SELECT *
			FROM '.SPBC_TBL_SCAN_FILES.'
			WHERE fast_hash = "'.$file_id.'"
			LIMIT 1';
		$sql_result = $wpdb->get_results($sql, ARRAY_A);
		$file_info = $sql_result[0];
		
		if(!empty($file_info)){
			
			$file_path = $file_info['status'] == 'QUARANTINED' ? $file_info['q_path'] : $root_path.$file_info['path'];
			
			if(file_exists($file_path)){
				if(is_writable($file_path)){
					
					// Getting file && API call
					$result = unlink($file_path);
					
					if($result){
						
						// Deleting row from DB
						$sql_result = $wpdb->query('DELETE FROM '.SPBC_TBL_SCAN_FILES.' WHERE fast_hash = "'.$file_id.'"');
							
						if($sql_result !== false){
							$output = array('success' => true);
						}else
							$output = array('error' => true, 'error_string' =>'DB_COULDNT_DELETE_ROW');
					}else
						$output = array('error' => true, 'error_string' =>'FILE_COULDNT_DELETE');
				}else
					$output = array('error' => true, 'error_string' =>'FILE_NOT_WRITABLE');
			}else
				$output = array('error' => true, 'error_string' =>'FILE_NOT_EXISTS');
		}else
			$output = array('error' => true, 'error_string' =>'FILE_NOT_FOUND');
	}else
		$output = array('error' => true, 'error_string' =>'WRONG_FILE_ID');
	
	$exec_time = microtime(true) - $time_start;
	$output['exec_time'] = $exec_time;
	
	if($direct_call)
		return $output;
	else
		die(json_encode($output));
}

function spbc_scanner_file_approve($direct_call = false, $file_id = null){
	
	if(!$direct_call)
		check_ajax_referer('spbc_secret_nonce', 'security');
	
	$time_start = microtime(true);
	
	global $spbc, $wpdb;
	
	$root_path = spbc_get_root_path();
	$file_id = $direct_call
		? ($file_id ? $file_id : false)
		: (!empty($_POST['file_id']) ? $_POST['file_id'] : false);
	
	if($file_id){
		
		// Getting file info.
		$sql = 'SELECT path, full_hash
			FROM '.SPBC_TBL_SCAN_FILES.'
			WHERE fast_hash = "'.$file_id.'"
			LIMIT 1';
		$sql_result = $wpdb->get_results($sql, ARRAY_A);
		$file_info = $sql_result[0];
		
		if(!empty($file_info)){
			if(file_exists($root_path.$file_info['path'])){
				if(is_readable($root_path.$file_info['path'])){
					
					// Getting file && API call
					$md5 = md5_file($root_path.$file_info['path']);
					
					if($md5){
						
						$sql = 'UPDATE '.SPBC_TBL_SCAN_FILES.'
							SET status = "APROVED", severity = NULL, real_full_hash = "'.$md5.'"
							WHERE fast_hash = "'.$file_id.'"';
						$sql_result = $wpdb->get_results($sql, ARRAY_A);
							
						if($sql_result !== false){
							$output = array('success' => true);
						}else
							$output = array('error' => true, 'error_string' =>'DB_COULDNT_UPDATE_ROW_APPROVE');
					}else
						$output = array('error' => true, 'error_string' =>'FILE_COULDNT_MD5');
				}else
					$output = array('error' => true, 'error_string' =>'FILE_NOT_READABLE');
			}else
				$output = array('error' => true, 'error_string' =>'FILE_NOT_EXISTS');
		}else
			$output = array('error' => true, 'error_string' =>'FILE_NOT_FOUND');
	}else
		$output = array('error' => true, 'error_string' =>'WRONG_FILE_ID');
	
	$exec_time = microtime(true) - $time_start;
	$output['exec_time'] = $exec_time;
	
	if($direct_call)
		return $output;
	else
		die(json_encode($output));
}

function spbc_scanner_file_disapprove($direct_call = false, $file_id = null){
	
	if(!$direct_call)
		check_ajax_referer('spbc_secret_nonce', 'security');
	
	$time_start = microtime(true);
	
	global $spbc, $wpdb;
	
	$root_path = spbc_get_root_path();
	$file_id = $direct_call
		? ($file_id ? $file_id : false)
		: (!empty($_POST['file_id']) ? $_POST['file_id'] : false);
	
	if($file_id){
		
		// Getting file info.
		$sql = 'SELECT path, full_hash
			FROM '.SPBC_TBL_SCAN_FILES.'
			WHERE fast_hash = "'.$file_id.'"
			LIMIT 1';
		$sql_result = $wpdb->get_results($sql, ARRAY_A);
		$file_info = $sql_result[0];
		
		if(!empty($file_info)){
			if(file_exists($root_path.$file_info['path'])){
				if(is_readable($root_path.$file_info['path'])){
					
					// Getting file && API call
					$md5 = md5_file($root_path.$file_info['path']);
					
					if($md5){
						
						$sql = 'UPDATE '.SPBC_TBL_SCAN_FILES.'
							SET status = "UNKNOWN", severity = NULL, real_full_hash = "'.$md5.'"
							WHERE fast_hash = "'.$file_id.'"';
						$sql_result = $wpdb->get_results($sql, ARRAY_A);
							
						if($sql_result !== false){
							$output = array('success' => true);
						}else
							$output = array('error' => true, 'error_string' =>'DB_COULDNT_UPDATE_ROW_APPROVE');
					}else
						$output = array('error' => true, 'error_string' =>'FILE_COULDNT_MD5');
				}else
					$output = array('error' => true, 'error_string' =>'FILE_NOT_READABLE');
			}else
				$output = array('error' => true, 'error_string' =>'FILE_NOT_EXISTS');
		}else
			$output = array('error' => true, 'error_string' =>'FILE_NOT_FOUND');
	}else
		$output = array('error' => true, 'error_string' =>'WRONG_FILE_ID');
	
	$exec_time = microtime(true) - $time_start;
	$output['exec_time'] = $exec_time;
	
	if($direct_call)
		return $output;
	else
		die(json_encode($output));
}

function spbc_scanner_file_view($direct_call = false, $file_id = null){
	
	if(!$direct_call)
		check_ajax_referer('spbc_secret_nonce', 'security');
	
	$time_start = microtime(true);
	
	global $spbc, $wpdb;
	
	$root_path = spbc_get_root_path();
	$file_id = $direct_call
		? $file_id ? $file_id : false
		: !empty($_POST['file_id']) ? $_POST['file_id'] : false;
	
	if($file_id){
		
		// Getting file info.
		$sql = 'SELECT *
			FROM '.SPBC_TBL_SCAN_FILES.'
			WHERE fast_hash = "'.$file_id.'"
			LIMIT 1';
		$sql_result = $wpdb->get_results($sql, ARRAY_A);
		$file_info = $sql_result[0];
		
		if(!empty($file_info)){
			
			$file_path = $file_info['status'] == 'QUARANTINED' ? $file_info['q_path'] : $root_path.$file_info['path'];
			
			if(file_exists($file_path)){
				if(is_readable($file_path)){
					
					// Getting file && API call
					$file = file($file_path);
					
					if(count($file)){
						
						$file_text = array();
						for($i=0; isset($file[$i]); $i++){
							$file_text[$i+1] = htmlspecialchars($file[$i]);
							$file_text[$i+1] = preg_replace("/[^\S]{4}/", "&nbsp;", $file_text[$i+1]);
						}
							
						if(!empty($file_text)){
							$output = array('success' => true, 'file' => $file_text, 'file_path' => $file_path, 'difference' => $file_info['difference'], 'weak_spots' => $file_info['weak_spots']);
						}else
							$output = array('error' => true, 'error_string' =>'FILE_TEXT_EMPTY');
					}else
						$output = array('error' => true, 'error_string' =>'FILE_EMPTY');
				}else
					$output = array('error' => true, 'error_string' =>'FILE_NOT_READABLE');
			}else
				$output = array('error' => true, 'error_string' =>'FILE_NOT_EXISTS');
		}else
			$output = array('error' => true, 'error_string' =>'FILE_NOT_FOUND');
	}else
		$output = array('error' => true, 'error_string' =>'WRONG_FILE_ID');
	
	$exec_time = microtime(true) - $time_start;
	$output['exec_time'] = $exec_time;
	
	if($direct_call)
		return $output;
	else
		die(json_encode($output));
}

function spbc_scanner_file_compare($direct_call = false, $file_id = null, $platform = 'wordpress'){
	
	if(!$direct_call)
		check_ajax_referer('spbc_secret_nonce', 'security');
	
	$time_start = microtime(true);
	
	global $spbc, $wpdb, $wp_version;
	
	$cms_version = $wp_version;
	$root_path = spbc_get_root_path();
	
	$file_id = $direct_call
		? $file_id ? $file_id : false
		: !empty($_POST['file_id']) ? $_POST['file_id'] : false;
	
	if($file_id){
		
		// Getting file info.
		$sql = 'SELECT path, status, severity, weak_spots, difference
			FROM '.SPBC_TBL_SCAN_FILES.'
			WHERE fast_hash = "'.$file_id.'"
			LIMIT 1';
		$sql_result = $wpdb->get_results($sql, ARRAY_A);
		$file_info = $sql_result[0];
		
		if(!empty($file_info)){
			if(file_exists($root_path.$file_info['path'])){
				if(is_readable($root_path.$file_info['path'])){
					
					// Getting file && API call
					$file = file($root_path.$file_info['path']);
					
					if(count($file)){
						
						$file_text = array();
						for($i=0; isset($file[$i]); $i++){
							$file_text[$i+1] = htmlspecialchars($file[$i]);
							$file_text[$i+1] = preg_replace("/[^\S]{4}/", "&nbsp;", $file_text[$i+1]);
						}
						if(!empty($file_text)){
							
							$file_original = file('http://cleantalk-security.s3.amazonaws.com/cms_sources/'.$platform.'/'.$cms_version.str_replace('\\', '/', $file_info['path']));
														
							if($file_original){
								
								$file_original_text = array();
								for($i=0; isset($file_original[$i]); $i++){
									$file_original_text[$i+1] = htmlspecialchars($file_original[$i]);
									$file_original_text[$i+1] = preg_replace("/[^\S]{4}/", "&nbsp;", $file_original_text[$i+1]);
								}
								if(!empty($file_original_text)){
									$output = array('success' => true, 'file' => $file_text, 'file_original' => $file_original_text, 'file_path' => $root_path.$file_info['path'], 'weak_spots' => $file_info['weak_spots'], 'difference' => $file_info['difference']);
								}else
									$output = array('error' => true, 'error_string' =>'FILE_ORIGINAL_TEXT_EMPTY');
							}else
								$output = array('error' => true, 'error_string' =>'GET_FILE_REMOTE_FAILED');
						}else
							$output = array('error' => true, 'error_string' =>'FILE_TEXT_EMPTY');
					}else
						$output = array('error' => true, 'error_string' =>'FILE_EMPTY');
				}else
					$output = array('error' => true, 'error_string' =>'FILE_NOT_READABLE');
			}else
				$output = array('error' => true, 'error_string' =>'FILE_NOT_EXISTS');
		}else
			$output = array('error' => true, 'error_string' =>'FILE_NOT_FOUND');
	}else
		$output = array('error' => true, 'error_string' =>'WRONG_FILE_ID');
	
	$exec_time = microtime(true) - $time_start;
	$output['exec_time'] = $exec_time;
	
	if($direct_call)
		return $output;
	else
		die(json_encode($output));
}

function spbc_scanner_file_replace($direct_call = false, $file_id = null, $platform = 'wordpress'){
	
	if(!$direct_call)
		check_ajax_referer('spbc_secret_nonce', 'security');
	
	$time_start = microtime(true);
	
	global $spbc, $wpdb, $wp_version;
	
	$cms_version = $wp_version;
	$root_path = spbc_get_root_path();
	
	$file_id = $direct_call
		? ($file_id ? $file_id : false)
		: (!empty($_POST['file_id']) ? $_POST['file_id'] : false);
	
	if($file_id){
		
		// Getting file info.
		$sql = 'SELECT path, status, severity
			FROM '.SPBC_TBL_SCAN_FILES.'
			WHERE fast_hash = "'.$file_id.'"
			LIMIT 1';
		$sql_result = $wpdb->get_results($sql, ARRAY_A);
		$file_info = $sql_result[0];
		
		if(!empty($file_info)){
			if(file_exists($root_path.$file_info['path'])){
				if(is_writable($root_path.$file_info['path'])){
					
					// Getting file && API call
					$original_file = file_get_contents('http://cleantalk-security.s3.amazonaws.com/cms_sources/'.$platform.'/'.$cms_version.str_replace('\\', '/', $file_info['path']));
					
					if($original_file){
						
						$file_desc = fopen($root_path.$file_info['path'], 'w');
						
						if($file_desc){
							
							$res_fwrite = fwrite($file_desc, $original_file);
							
							if($res_fwrite){
								
								$res_fclose = fclose($file_desc);
								
								$db_result = $wpdb->query(
									'DELETE FROM '.SPBC_TBL_SCAN_FILES
									.' WHERE fast_hash = "'.$file_id.'";'
								);
								
								if($db_result){
									$output = array('success' => true,);
								}else
									$output = array('error' => true, 'error_string' =>'FILE_DB_DELETE_FAIL');
							}else
								$output = array('error' => true, 'error_string' =>'FILE_COULDNT_WRITE');
						}else
							$output = array('error' => true, 'error_string' =>'FILE_COULDNT_OPEN');
					}else
						$output = array('error' => true, 'error_string' =>'GET_FILE_FAILED');
				}else
					$output = array('error' => true, 'error_string' =>'FILE_NOT_WRITABLE');
			}else
				$output = array('error' => true, 'error_string' =>'FILE_NOT_EXISTS');
		}else
			$output = array('error' => true, 'error_string' =>'FILE_NOT_FOUND');
	}else
		$output = array('error' => true, 'error_string' =>'WRONG_FILE_ID');
	
	$exec_time = microtime(true) - $time_start;
	$output['exec_time'] = $exec_time;
	
	if($direct_call)
		return $output;
	else
		die(json_encode($output));
}

function spbc_scanner_file_quarantine($direct_call = false, $file_id = null){
	
	global $wpdb, $spbc;
	
	if(!$direct_call)
		check_ajax_referer('spbc_secret_nonce', 'security');
	
	$root_path = spbc_get_root_path();
	$file_id = $direct_call
		? ($file_id ? $file_id : false)
		: (!empty($_POST['file_id']) ? $_POST['file_id'] : false);
	
	if($file_id){
		
		// Getting file info.
		$sql = 'SELECT *
			FROM '.SPBC_TBL_SCAN_FILES.'
			WHERE fast_hash = "'.$file_id.'"
			LIMIT 1';
		$sql_result = $wpdb->get_results($sql, ARRAY_A);
		$file_info = $sql_result[0];
		
		if(!empty($file_info)){
			if(file_exists($root_path.$file_info['path'])){
				if(is_writable($root_path.$file_info['path'])){
					$q_path = SPBC_PLUGIN_DIR.'quarantine/'
						.str_replace('/', '__', str_replace('\\', '__', $file_info['path'])).'___'
						.md5($file_info['path'].rand(0, 99999999)).'.punished';
					if(copy($root_path.$file_info['path'], $q_path)){
						$result = $wpdb->update(
							SPBC_TBL_SCAN_FILES,
							array ('status' => 'QUARANTINED', 'q_status' => $file_info['status'], 'q_path' => $q_path, 'q_time' => time(),),
							array ('path' => $file_info['path']),
							array ( '%s', '%s', '%s', '%d', ),
							array ( '%s' )
						);
						if($result !== false && $result > 0){
							if(unlink($root_path.$file_info['path'])){
								$response = SpbcHelper::http__request(get_option('siteurl'));
								if( !spbc_search_page_errors($response[0]) ){
									$output = array('success' => true,);
								}else{
									$output = array('error' => true, 'error_string' =>'WEBSITE_RESPONSE_BAD');
									$result = spbc_scanner_file_quarantine__restore(true, $file_info['fast_hash']);
									$output['error_string'] .= !empty($result['error']) ? ' REVERT_FAILED '.$result['error_string'] : ' REVERT_OK';
								}
							}else
								$output = array('error' => true, 'error_string' =>'DELETE_FAILED');
						}else
							$output = array('error' => true, 'error_string' =>'UPDATE_TABLE_FAILED');
					}else
						$output = array('error' => true, 'error_string' =>'COPY_FAILED');
				}else
					$output = array('error' => true, 'error_string' =>'FILE_NOT_WRITABLE');
			}else
				$output = array('error' => true, 'error_string' =>'FILE_NOT_EXISTS');
		}else
			$output = array('error' => true, 'error_string' =>'FILE_NOT_FOUND');
	}else
		$output = array('error' => true, 'error_string' =>'WRONG_FILE_ID');
	
	if($direct_call) return $output; else die(json_encode($output));
}

function spbc_scanner_file_quarantine__restore($direct_call = false, $file_id = null){
	
	global $wpdb;
	
	if(!$direct_call)
		check_ajax_referer('spbc_secret_nonce', 'security');
	
	$root_path = spbc_get_root_path();
	$file_id = $direct_call
		? ($file_id ? $file_id : false)
		: (!empty($_POST['file_id']) ? $_POST['file_id'] : false);
	
	if($file_id){
		
		// Getting file info.
		$sql = 'SELECT *
			FROM '.SPBC_TBL_SCAN_FILES.'
			WHERE fast_hash = "'.$file_id.'"
			LIMIT 1';
		$sql_result = $wpdb->get_results($sql, ARRAY_A);
		$file_info = $sql_result[0];
		
		if(!empty($file_info)){
			if(file_exists($file_info['q_path'])){
				if(is_writable($file_info['q_path'])){
					if(copy($file_info['q_path'], $root_path.$file_info['path'])){
						$result = $wpdb->update(
							SPBC_TBL_SCAN_FILES,
							array ('status' => $file_info['q_status'], 'q_status' => null, 'q_path' => null, 'q_time' => null,),
							array ('fast_hash' => $file_info['fast_hash']),
							array ( '%s', '%s', '%d', ),
							array ( '%s' )
						);
						if($result !== false && $result > 0){
							if(unlink($file_info['q_path'])){
								$output = array('success' => true,);
							}else
								$output = array('error' => true, 'error_string' =>'DELETE_FAILED');
						}else
							$output = array('error' => true, 'error_string' =>'UPDATE_TABLE_FAILED');
					}else
						$output = array('error' => true, 'error_string' =>'COPY_FAILED');
				}else
					$output = array('error' => true, 'error_string' =>'FILE_NOT_WRITABLE');
			}else
				$output = array('error' => true, 'error_string' =>'FILE_NOT_EXISTS');
		}else
			$output = array('error' => true, 'error_string' =>'FILE_NOT_FOUND');
	}else
		$output = array('error' => true, 'error_string' =>'WRONG_FILE_ID');
	
	if($direct_call) return $output; else die(json_encode($output));
}

function spbc_scanner_file_download($direct_call = false, $file_id = null){
	
	global $wpdb;
	
	$file_id = $direct_call
		? ($file_id ? $file_id : false)
		: (!empty($_POST['file_id']) ? $_POST['file_id'] : false);
	
	if($file_id){
		
		// Getting file info.
		$sql = 'SELECT *
			FROM '.SPBC_TBL_SCAN_FILES.'
			WHERE fast_hash = "'.$file_id.'"
			LIMIT 1';
		$sql_result = $wpdb->get_results($sql, ARRAY_A);
		
		$file_info = $sql_result[0];
		
		if(!empty($file_info)){
			
			if(file_exists($file_info['q_path'])){
				
				if(is_readable($file_info['q_path'])){
					
					// Getting file && API call
					$file = file_get_contents($file_info['q_path']);
					
					if(!empty($file)){
						
						$output = array(
							'file_name'    => preg_replace('/.*(\/|\\\\)(.*)/', '$2', $file_info['path']),
							'file_content' => $file,
						);
						
					}else
						$output = array('error' => true, 'error_string' =>'FILE_EMPTY');
				}else
					$output = array('error' => true, 'error_string' =>'FILE_NOT_READABLE');
			}else
				$output = array('error' => true, 'error_string' =>'FILE_NOT_EXISTS');
		}else
			$output = array('error' => true, 'error_string' =>'FILE_NOT_FOUND');
	}else
		$output = array('error' => true, 'error_string' =>'WRONG_FILE_ID');
	
	if($direct_call) return $output; else die(json_encode($output));
}

function spbc_size_to_string($size){
	$size = strrev((string)$size);
	$result = '';
	for($i=0; isset($size[$i]); $i++)
		$result .= ($i%3 == 0 ? ' ' : '') . $size[$i];
	
	return strrev($result);
}

function spbc_is_windows(){
	return strpos(strtolower(php_uname('s')), 'windows') !== false ? true : false;
}

function spbc_search_page_errors($string_page){
	return (
		   empty($string_page)
		|| strpos($string_page, 'Notice')                 !== false
		|| strpos($string_page, 'Warning')                !== false
		|| strpos($string_page, 'Fatal error')            !== false
		|| stripos($string_page, 'internal server error') !== false
	);
}

function spbc_get_plugins(){
	$output = array();
	foreach(glob(WP_PLUGIN_DIR.'/*') as $plugin_dir){
		if(is_dir($plugin_dir)){
			foreach(glob($plugin_dir.'/*') as $plugin_file){
				if(is_file($plugin_file)){
					$plugin = get_file_data($plugin_file, array('Name' => 'Plugin Name', 'Version' => 'Version'));
					if(!empty($plugin['Version'])){
						$output[preg_replace('/^(.*)(\/|\\\\).*/', '$1', substr($plugin_file, strlen(WP_PLUGIN_DIR)+1))] = $plugin;
					}
				}
			}
		}
	}
	return $output;
}

function spbc_get_themes(){
	$output = array();
	foreach(glob(get_theme_root().'/*') as $theme_dir){
		if(is_dir($theme_dir)){
			foreach(glob($theme_dir.'/*') as $theme_file){
				if(strpos($theme_file, 'style.css') !== false){
					$theme = get_file_data($theme_file,	array('Name' => 'Theme Name', 'Version' => 'Version'));
					if(!empty($theme['Version'])){
						$output[substr($theme_file, strlen(get_theme_root())+1, -(strlen('/style.css')))] = $theme;
					}
				}
			}
		}
	}
	return $output;
}